Loading...
Searching...
No Matches
juce::MPESynthesiserBase Struct Referenceabstract

## Detailed Description

Derive from this class to create a basic audio generator capable of MPE.

Implement the callbacks of MPEInstrument::Listener (noteAdded, notePressureChanged etc.) to let your audio generator know that MPE notes were triggered, modulated, or released. What to do inside them, and how that influences your audio generator, is up to you!

This class uses an instance of MPEInstrument internally to handle the MPE note state logic.

This class is a very low-level base class for an MPE instrument. If you need something more sophisticated, have a look at MPESynthesiser. This class extends MPESynthesiserBase by adding the concept of voices that can play notes, a voice stealing algorithm, and much more.

See also
  MPESynthesiser, MPEInstrument

The documentation for this struct was generated from the following file:

- juce_audio_basics/mpe/juce_MPESynthesiserBase.h

Inheritance diagram for juce::MPESynthesiserBase:

## Public Types

using | TrackingMode = MPEInstrument::TrackingMode

## Public Member Functions

| MPESynthesiserBase ()
| Constructor.
| MPESynthesiserBase (MPEInstrument &instrument)
| Constructor.
MPEZoneLayout | getZoneLayout () const noexcept
| Returns the synthesiser's internal MPE zone layout.
void | setZoneLayout (MPEZoneLayout newLayout)
| Re-sets the synthesiser's internal MPE zone layout to the one passed in.
virtual void | setCurrentPlaybackSampleRate (double sampleRate)
| Tells the synthesiser what the sample rate is for the audio it's being used to render.
double | getSampleRate () const noexcept
| Returns the current target sample rate at which rendering is being done.
template<typename floatType>
void | renderNextBlock (AudioBuffer< floatType > &outputAudio, const MidiBuffer &inputMidi, int startSample, int numSamples)
| Creates the next block of audio output.
virtual void | handleMidiEvent (const MidiMessage &)
| Handle incoming MIDI events (called from renderNextBlock).
void | setMinimumRenderingSubdivisionSize (int numSamples, bool shouldBeStrict=false) noexcept
| Sets a minimum limit on the size to which audio sub-blocks will be divided when rendering.
void | enableLegacyMode (int pitchbendRange=2, Range< int > channelRange=Range< int >(1, 17))
| Puts the synthesiser into legacy mode.
bool | isLegacyModeEnabled () const noexcept
| Returns true if the instrument is in legacy mode, false otherwise.
Range< int > | getLegacyModeChannelRange () const noexcept
| Returns the range of MIDI channels (1-16) to be used for notes when in legacy mode.
void | setLegacyModeChannelRange (Range< int > channelRange)
| Re-sets the range of MIDI channels (1-16) to be used for notes when in legacy mode.
int | getLegacyModePitchbendRange () const noexcept
| Returns the pitchbend range in semitones (0-96) to be used for notes when in legacy mode.
void | setLegacyModePitchbendRange (int pitchbendRange)
| Re-sets the pitchbend range in semitones (0-96) to be used for notes when in legacy mode.
void | setPressureTrackingMode (TrackingMode modeToUse)
| Set the MPE tracking mode for the pressure dimension.
void | setPitchbendTrackingMode (TrackingMode modeToUse)
| Set the MPE tracking mode for the pitchbend dimension.
void | setTimbreTrackingMode (TrackingMode modeToUse)
| Set the MPE tracking mode for the timbre dimension.
Public Member Functions inherited from juce::MPEInstrument::Listener
virtual | ~Listener ()=default
| Destructor.
virtual void | noteAdded (MPENote newNote)
| Implement this callback to be informed whenever a new expressive MIDI note is triggered.
virtual void | notePressureChanged (MPENote changedNote)
| Implement this callback to be informed whenever a currently playing MPE note's pressure value changes.
virtual void | notePitchbendChanged (MPENote changedNote)
| Implement this callback to be informed whenever a currently playing MPE note's pitchbend value changes.
virtual void | noteTimbreChanged (MPENote changedNote)
| Implement this callback to be informed whenever a currently playing MPE note's timbre value changes.
virtual void | noteKeyStateChanged (MPENote changedNote)
| Implement this callback to be informed whether a currently playing MPE note's key state (whether the key is down and/or the note is sustained) has changed.
virtual void | noteReleased (MPENote finishedNote)
| Implement this callback to be informed whenever an MPE note is released (either by a note-off message, or by a sustain/sostenuto pedal release for a note that already received a note-off), and should therefore stop playing.
virtual void | zoneLayoutChanged ()
| Implement this callback to be informed whenever the MPE zone layout or legacy mode settings of this instrument have been changed.

## Protected Member Functions

virtual void | renderNextSubBlock (AudioBuffer< float > &outputAudio, int startSample, int numSamples)=0
| Implement this method to render your audio inside.
virtual void | renderNextSubBlock (AudioBuffer< double > &, int, int)
| Implement this method if you want to render 64-bit audio as well; otherwise leave blank.

## Protected Attributes

MPEInstrument & | instrument

## Member Typedef Documentation

## TrackingMode

using juce::MPESynthesiserBase::TrackingMode = MPEInstrument::TrackingMode

## Constructors and Destructors

## MPESynthesiserBase() [1/2]

juce::MPESynthesiserBase::MPESynthesiserBase | ( |  | ) |

Constructor.

## MPESynthesiserBase() [2/2]

juce::MPESynthesiserBase::MPESynthesiserBase | ( | MPEInstrument & | instrument | ) |

Constructor.

If you use this constructor, the synthesiser will use the provided instrument object to handle the MPE note state logic. This is useful if you want to use an instance of your own class derived from MPEInstrument for the MPE logic.

References instrument.

## Member Functions

## getZoneLayout()

MPEZoneLayout juce::MPESynthesiserBase::getZoneLayout | ( |  | ) | const

noexcept

Returns the synthesiser's internal MPE zone layout.

This happens by value, to enforce thread-safety and class invariants.

## setZoneLayout()

void juce::MPESynthesiserBase::setZoneLayout | ( | MPEZoneLayout | newLayout | ) |

Re-sets the synthesiser's internal MPE zone layout to the one passed in.

As a side effect, this will discard all currently playing notes, call noteReleased for all of them, and disable legacy mode (if previously enabled).

References setZoneLayout().

Referenced by setZoneLayout().

## setCurrentPlaybackSampleRate()

virtual void juce::MPESynthesiserBase::setCurrentPlaybackSampleRate | ( | double | sampleRate | ) |

virtual

Tells the synthesiser what the sample rate is for the audio it's being used to render.

Reimplemented in juce::MPESynthesiser.

References setCurrentPlaybackSampleRate().

Referenced by setCurrentPlaybackSampleRate().

## getSampleRate()

double juce::MPESynthesiserBase::getSampleRate | ( |  | ) | const

inline noexcept

Returns the current target sample rate at which rendering is being done.

Subclasses may need to know this so that they can pitch things correctly.

References getSampleRate().

Referenced by getSampleRate().

## renderNextBlock()

template<typename floatType>

void juce::MPESynthesiserBase::renderNextBlock | ( | AudioBuffer< floatType > & | outputAudio,
|  | const MidiBuffer & | inputMidi,
|  | int | startSample,
|  | int | numSamples )

Creates the next block of audio output.

Call this to make sound. This will chop up the AudioBuffer into subBlock pieces separated by events in the MIDI buffer, and then call renderNextSubBlock on each one of them. In between you will get calls to noteAdded/Changed/Finished, where you can update parameters that depend on those notes to use for your audio rendering.

Parameters

  outputAudio | Buffer into which audio will be rendered
  inputMidi | MIDI events to process
  startSample | The first sample to process in both buffers
  numSamples | The number of samples to process

## handleMidiEvent()

virtual void juce::MPESynthesiserBase::handleMidiEvent | ( | const MidiMessage & |  | ) |

virtual

Handle incoming MIDI events (called from renderNextBlock).

The default implementation provided here simply forwards everything to MPEInstrument::processNextMidiEvent, where it is used to update the MPE notes, zones etc. MIDI messages not relevant for MPE are ignored.

This method can be overridden if you need to do custom MIDI handling on top of MPE. The MPESynthesiser class overrides this to implement callbacks for MIDI program changes and non-MPE-related MIDI controller messages.

Reimplemented in juce::MPESynthesiser.

## setMinimumRenderingSubdivisionSize()

void juce::MPESynthesiserBase::setMinimumRenderingSubdivisionSize | ( | int | numSamples,
|  | bool | shouldBeStrict = false )

noexcept

Sets a minimum limit on the size to which audio sub-blocks will be divided when rendering.

When rendering, the audio blocks that are passed into renderNextBlock() will be split up into smaller blocks that lie between all the incoming midi messages, and it is these smaller sub-blocks that are rendered with multiple calls to renderVoices().

Obviously in a pathological case where there are midi messages on every sample, then renderVoices() could be called once per sample and lead to poor performance, so this setting allows you to set a lower limit on the block size.

The default setting is 32, which means that midi messages are accurate to about < 1ms accuracy, which is probably fine for most purposes, but you may want to increase or decrease this value for your synth.

If shouldBeStrict is true, the audio sub-blocks will strictly never be smaller than numSamples.

If shouldBeStrict is false (default), the first audio sub-block in the buffer is allowed to be smaller, to make sure that the first MIDI event in a buffer will always be sample-accurate (this can sometimes help to avoid quantisation or phasing issues).

## enableLegacyMode()

void juce::MPESynthesiserBase::enableLegacyMode | ( | int | pitchbendRange = 2,
|  | Range< int > | channelRange = Range< int >(1, 17) )

Puts the synthesiser into legacy mode.

Parameters

  pitchbendRange | The note pitchbend range in semitones to use when in legacy mode. Must be between 0 and 96, otherwise behaviour is undefined. The default pitchbend range in legacy mode is +/- 2 semitones.
  channelRange | The range of MIDI channels to use for notes when in legacy mode. The default is to use all MIDI channels (1-16).

To get out of legacy mode, set a new MPE zone layout using setZoneLayout.

References enableLegacyMode().

Referenced by enableLegacyMode().

## isLegacyModeEnabled()

bool juce::MPESynthesiserBase::isLegacyModeEnabled | ( |  | ) | const

noexcept

Returns true if the instrument is in legacy mode, false otherwise.

References isLegacyModeEnabled().

Referenced by isLegacyModeEnabled().

## getLegacyModeChannelRange()

Range< int > juce::MPESynthesiserBase::getLegacyModeChannelRange | ( |  | ) | const

noexcept

Returns the range of MIDI channels (1-16) to be used for notes when in legacy mode.

References getLegacyModeChannelRange().

Referenced by getLegacyModeChannelRange().

## setLegacyModeChannelRange()

void juce::MPESynthesiserBase::setLegacyModeChannelRange | ( | Range< int > | channelRange | ) |

Re-sets the range of MIDI channels (1-16) to be used for notes when in legacy mode.

References setLegacyModeChannelRange().

Referenced by setLegacyModeChannelRange().

## getLegacyModePitchbendRange()

int juce::MPESynthesiserBase::getLegacyModePitchbendRange | ( |  | ) | const

noexcept

Returns the pitchbend range in semitones (0-96) to be used for notes when in legacy mode.

References getLegacyModePitchbendRange().

Referenced by getLegacyModePitchbendRange().

## setLegacyModePitchbendRange()

void juce::MPESynthesiserBase::setLegacyModePitchbendRange | ( | int | pitchbendRange | ) |

Re-sets the pitchbend range in semitones (0-96) to be used for notes when in legacy mode.

References setLegacyModePitchbendRange().

Referenced by setLegacyModePitchbendRange().

## setPressureTrackingMode()

void juce::MPESynthesiserBase::setPressureTrackingMode | ( | TrackingMode | modeToUse | ) |

Set the MPE tracking mode for the pressure dimension.

References setPressureTrackingMode().

Referenced by setPressureTrackingMode().

## setPitchbendTrackingMode()

void juce::MPESynthesiserBase::setPitchbendTrackingMode | ( | TrackingMode | modeToUse | ) |

Set the MPE tracking mode for the pitchbend dimension.

References setPitchbendTrackingMode().

Referenced by setPitchbendTrackingMode().

## setTimbreTrackingMode()

void juce::MPESynthesiserBase::setTimbreTrackingMode | ( | TrackingMode | modeToUse | ) |

Set the MPE tracking mode for the timbre dimension.

References setTimbreTrackingMode().

Referenced by setTimbreTrackingMode().

## renderNextSubBlock() [1/2]

virtual void juce::MPESynthesiserBase::renderNextSubBlock | ( | AudioBuffer< float > & | outputAudio,
|  | int | startSample,
|  | int | numSamples )

protected pure virtual

Implement this method to render your audio inside.

See also
  renderNextBlock

Implemented in juce::MPESynthesiser.

References renderNextSubBlock().

Referenced by renderNextSubBlock(), and renderNextSubBlock().

## renderNextSubBlock() [2/2]

virtual void juce::MPESynthesiserBase::renderNextSubBlock | ( | AudioBuffer< double > & | ,
|  | int | ,
|  | int | )

inline protected virtual

Implement this method if you want to render 64-bit audio as well; otherwise leave blank.

Reimplemented in juce::MPESynthesiser.

References renderNextSubBlock().

## Member Data Documentation

## instrument

MPEInstrument& juce::MPESynthesiserBase::instrument

protected

Referenced by MPESynthesiserBase().

### Purchase

Get JUCE

### Discover

What's New in JUCE Features

### Learn

Documentaion Tutorials Made with JUCE Resources

### Support

JUCE Forum Newsletter Archive

### About

Contact Us JUCE Legal JUCE Licensing FAQ

### Events

Audio Developer Conference
© Raw Material Software Limited